import { NumericTextBoxComponent } from "@syncfusion/ej2-vue-inputs";
import { text, number } from "@storybook/addon-knobs";

function makeComponent() {
  return {
    components: { NumericTextBoxComponent },
    props: {
      format: {
        type: String,
        default: text("format", "####")
      },
      value: {
        type: Number,
        default: number("value", 4711)
      }
    },
    template: `<div><numeric-text-box-component ref="numeric" :value="value" :format="format" /></div>`,
    updated() {
      // triggered when format pattern changed
      console.log("updated", this.$refs.numeric.getText());
      this.$nextTick(function() {
        // the value of getText() does not yet match the updated format pattern
        console.log("text in nextTick:", this.$refs.numeric.getText());
      });
      const that = this;
      setTimeout(function() {
        // only here in setTimeout the value from getText() matches the updated format pattern
        console.log("text in setTimeout:", that.$refs.numeric.getText());
      }, 0);
    },
    created() {
      console.log("created");
    }
  };
}

export const asSimpleNumericTextBoxComponent = () => makeComponent();

export default { title: "NumericTextBoxComponent" };
